// DiskSpace.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

#define  MEOR  _T("\r\n")
#ifdef UNICODE
#define  sprtf wprintf
#else
#define  sprtf printf
#endif

DWORD SectorsPerCluster, BytesPerSector, NumberOfFreeClusters, TotalNumberOfClusters;
ULARGE_INTEGER FreeBytesAvailable, TotalNumberOfBytes, TotalNumberOfFreeBytes;
static TCHAR _s_kbuf64_1[264];
static TCHAR _s_kbuf64_2[264];
static TCHAR _s_kbuf64[264];
static TCHAR _s_cbbuf1[264];
static TCHAR _s_cbbuf2[264];

// get nice number (double)
TCHAR * get_d_num( double byts )
{
   TCHAR * pb = _s_kbuf64;
   if( byts < 1024 ) {
      StringCbPrintf(pb, 256, _T("%f bytes"), byts);
   } else if( byts < 1024*1024 ) {
      double ks = ((double)byts / 1024.0);
      StringCbPrintf(pb, 256, _T("%0.2f KB"), ks);
   } else if( byts < 1024*1024*1024 ) {
      double ms = ((double)byts / (1024.0*1024.0));
      StringCbPrintf(pb, 256, _T("%0.2f MB"), ms);
   } else {
      double gs = ((double)byts / (1024.0*1024.0*1024.0));
      StringCbPrintf(pb, 256, _T("%0.2f GB"), gs);
   }
   return pb;
}


TCHAR * get_k_num64( ULARGE_INTEGER uli )
{
   TCHAR * pb = _s_kbuf64;
   double byts = ((double)uli.HighPart * 4294967296.0);
   byts += uli.LowPart;
   return( get_d_num( byts ) );
}

TCHAR * comma_sep_number_string( TCHAR * pb1 )
{
   TCHAR * pb2 = _s_kbuf64_2;
   size_t len, i, rem, off;
   len = lstrlen(pb1);
   rem = (len % 3);
   off = 0;
   if(rem)
      rem++;
   for(i = 0; i < len; i++)
   {
      if( rem ) {
         rem--;
         if( i && ( rem == 0 ))
            pb2[off++] = ',';
      }
      if( rem == 0 )
         rem = 3;
      pb2[off++] = pb1[i];
   }
   pb2[off] = 0;
   return pb2;
}


TCHAR * get_comma_sep_number( ULARGE_INTEGER uli )
{
   TCHAR * pb1 = _s_kbuf64_1;
   StringCbPrintf(pb1, 256, _T("%I64u"), uli);
   return( comma_sep_number_string(pb1) );
}

DWORDLONG DoMult3_ints( DWORD dw1, DWORD dw2, DWORD dw3 )
{
	DWORDLONG	dwlr, dwl1, dwl2, dwl3;
	dwl1 = dw1;
	dwl2 = dw2;
	dwl3 = dw3;
	dwlr = dwl1 * dwl2;
	dwlr = dwlr * dwl3;
	return dwlr;
}

DWORDLONG DoMult3( DWORD dw1, DWORD dw2, DWORD dw3 )
{
   double dwl1, dwl2, dwl3, dwrd;
	DWORDLONG	dwlr;
	dwl1 = (double)dw1;
	dwl2 = (double)dw2;
	dwl3 = (double)dw3;
	dwrd = dwl1 * dwl2;
	dwrd = dwrd * dwl3;
   dwlr = (DWORDLONG)dwrd;
	return dwlr;
}

double dDoMult3( DWORD dw1, DWORD dw2, DWORD dw3 )
{
   double dwl1, dwl2, dwl3, dwrd;
	dwl1 = (double)dw1;
	dwl2 = (double)dw2;
	dwl3 = (double)dw3;
	dwrd = dwl1 * dwl2;
	dwrd = dwrd * dwl3;
	return dwrd;
}

TCHAR * get_trim_float( double db )
{
   TCHAR * pb1 = _s_cbbuf1;
   size_t len, i;
   size_t dot = 0;
   int allzero = 1;
   StringCbPrintf(pb1, 256, _T("%f"), db );
   len = lstrlen(pb1);
   for(i = 0; i < len; i++)
   {
      if( pb1[i] == '.' )
      {
         dot = i;
         i++;
         for(; i < len; i++)
         {
            if( pb1[i] != '0' )
            {
               allzero = 0;
               break;
            }
         }
      }
   }
   if(dot && allzero) {
      pb1[dot] = 0;
   }
   return pb1;
}

void GetDiskSpace( _TCHAR * ps )
{
   int shwn = 0;
   TCHAR * pb1 = _s_cbbuf1;
   TCHAR * pb2 = _s_cbbuf2;
   if( GetDiskFreeSpaceEx( ps, //  LPCTSTR lpDirectoryName,
      &FreeBytesAvailable,
      &TotalNumberOfBytes,
      &TotalNumberOfFreeBytes ) )
   {
      sprtf( _T("Disk %s:") MEOR, ps );
      StringCbPrintf(pb1, 256, _T("Total %s (%s bytes),") MEOR,
            get_k_num64( TotalNumberOfBytes ),
            get_comma_sep_number(TotalNumberOfBytes) );
      sprtf(pb1);
      sprtf( _T("Free  %s (%s bytes).") MEOR,
            get_k_num64( TotalNumberOfFreeBytes ),
            get_comma_sep_number(TotalNumberOfFreeBytes) );
      shwn++;
   }

   if( !shwn && GetDiskFreeSpace( ps, &SectorsPerCluster, &BytesPerSector,
         &NumberOfFreeClusters, &TotalNumberOfClusters) )
   {
      //DWORDLONG dwlfree = DoMult3( BytesPerSector, SectorsPerCluster, NumberOfFreeClusters );
      //DWORDLONG dwltot = DoMult3( BytesPerSector, SectorsPerCluster, TotalNumberOfClusters );
      double dwlfree = dDoMult3( BytesPerSector, SectorsPerCluster, NumberOfFreeClusters );
      double dwltot = dDoMult3( BytesPerSector, SectorsPerCluster, TotalNumberOfClusters );
      sprtf( _T("Disk %s:") MEOR, ps );
      //sprtf( _T("Total %lu bytes,") MEOR, dwlfree );
      //sprtf( _T("Free  %lu bytes.") MEOR, dwltot );
      //sprtf( _T("BPS:%u, SPC:%u, TOT:%u, FREE:%u.") MEOR,
      //   BytesPerSector, SectorsPerCluster, TotalNumberOfClusters, NumberOfFreeClusters );
      sprtf( _T("Total %s (%s bytes),") MEOR,
         get_d_num( dwltot ),
         comma_sep_number_string(get_trim_float(dwltot)) );
      sprtf( _T("Free  %s (%s bytes).") MEOR,
         get_d_num( dwlfree ),
         comma_sep_number_string(get_trim_float(dwlfree)) );
      shwn++;
   }
   
   if( !shwn ) {
      sprtf( _T("Disk %s: FAILED TO GET VALUES") MEOR, ps );
   }
}

int _tmain(int argc, _TCHAR* argv[])
{
   _TCHAR * ps = _T("C:\\.");
   if(argc > 1)
      ps = argv[1];

   GetDiskSpace(ps);
	return 0;
}

